/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2005 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls;

import java.util.HashMap;

import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshalParser;
import fr.gouv.finances.cp.xemelios.common.config.BlankModel;
import fr.gouv.finances.cp.xemelios.common.config.TextModel;
import fr.gouv.finances.cp.xemelios.controls.models.ControlModel;
import fr.gouv.finances.cp.xemelios.controls.models.ControlModelTech;
import fr.gouv.finances.cp.xemelios.controls.models.ControlsModel;
import fr.gouv.finances.cp.xemelios.controls.models.DocumentControlModel;
import fr.gouv.finances.cp.xemelios.controls.models.InputModel;
import fr.gouv.finances.cp.xemelios.controls.models.MessageModel;
import fr.gouv.finances.cp.xemelios.controls.models.OptionModel;
import fr.gouv.finances.cp.xemelios.controls.models.ParamModel;
import fr.gouv.finances.cp.xemelios.controls.models.ParamModelTech;
import fr.gouv.finances.cp.xemelios.controls.models.RefIdModel;
import fr.gouv.finances.cp.xemelios.controls.models.RegleModel;
import fr.gouv.finances.cp.xemelios.controls.models.SelectModel;

/**
 * Parser de definition de document
 * @author chm
 */
public class ControlParser extends XmlMarshalParser {
	public ControlParser() throws SAXException, ParserConfigurationException, FactoryConfigurationError {
		super(new Mapping(),true);
	}
	
	private static class Mapping extends HashMap<String,Class> {
		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3617293411154145847L;

		public Mapping() {
			put(ControlsModel.TAG,ControlsModel.class);
			put(ControlModel.TAG,ControlModel.class);
			put(ControlModelTech.TAG,ControlModelTech.class);
			put(DocumentControlModel.TAG,DocumentControlModel.class);
//			put(ElementLieModel.TAG,ElementLieModel.class);
			put(MessageModel.TAG,MessageModel.class);
			put(RefIdModel.TAG,RefIdModel.class);
			put(ParamModel.TAG,ParamModel.class);
			put(ParamModelTech.TAG,ParamModelTech.class);
			put(RegleModel.TAG,RegleModel.class);
			put(InputModel.TAG, InputModel.class);
			put(OptionModel.TAG,OptionModel.class);
			put(SelectModel.TAG,SelectModel.class);
			put(BlankModel.TAG,BlankModel.class);
                        //put(NamespaceModel.TAG,NamespaceModel.class);
                        //put(NSModel.TAG,NSModel.class);
			put("valeur",TextModel.class);
			put("libelle",TextModel.class);
			put("id",TextModel.class);
			put("sort",TextModel.class);
			put("br",TextModel.class);
			put("ul",TextModel.class);
			put("li",TextModel.class);
		}
	}
}
